/*  $Id: File.h,v 1.3 1999/06/20 01:27:16 shaggy Exp $
 *      relative path: ./lib/bff/elf32
 */

#pragma interface

#include <unistd.h>
#include "Error.h"
#include "vector.H"

class File {
	int _fd;
public:
	File(const char *fname, const char *path = 0);
	File(int fd) { _fd = fd; }
	~File();
	ssize_t read(DStr buf) const;
	ssize_t write(CStr buf) const;
	ssize_t read(void *adr, size_t size) const
		{ read(DStr((char*)adr, size)); }
	ssize_t write(const void *adr, size_t size) const
		{ write(CStr((const char*)adr, size)); }
	off_t seek(off_t p) const;
	off_t tell() const;
	ssize_t read_at(off_t p, DStr buf) const;
	ssize_t write_at(off_t p, CStr buf) const;
	ssize_t read_at(off_t p, void *adr, size_t size) const
		{ read_at(p, DStr((char*)adr, size)); }
	ssize_t write_at(off_t p, const void *adr, size_t size) const
		{ write_at(p, CStr((const char*)adr, size)); }
};



#ifdef __dynamic__

#ifndef __dynamic_interface__
#include "File.dh"
#else

interface "File.dh"
	Class File: File
		read buf
		write buf
end

#endif // __dynamic_interface__

#endif // __dynamic__

