/*  $Id: crt_head.S,v 1.6 1999/06/20 01:27:21 shaggy Exp $
 *      relative path: ./lib/boot/m-pc
 */ 

.text

// NOTE: (this applies to all assembly code)
//   C functions on the 386 will automatically save all registers
//   used except eax, ecx, and edx



// call global constructors for either elf or a.out format:
//	a.out:  len xxx xxx xxx etc...
//	elf:    -1 xxx xxx xxx 0


#ifdef __ELF__
#	define C(n)	n
#else
#	define C(n)	_##n
#endif


.globl __do_global_ctors
__do_global_ctors:
	pushl	%ebx
	movl	$C(__CTOR_LIST__),%ebx
	movl	(%ebx),%eax
	cmpl	$-1,%eax
	je	1f				// for ELF-style
	leal	C(__CTOR_LIST__)+4(,%eax,4),%ebx // for a.out style
	jmp	2f

1:	addl	$4,%ebx			
	cmpl	$0,(%ebx)			// find end of list
	jne	1b

2:	subl	$4,%ebx
	cmpl	$C(__CTOR_LIST__),%ebx		// if at start
	je	3f				// then stop
	movl	(%ebx),%eax			
	call	*%eax				// else call constructor
	jmp	2b				// and loop

3:	popl	%ebx
	ret


.globl __do_global_dtors
__do_global_dtors:
	pushl	%ebx
	movl	$C(__DTOR_LIST__),%ebx

1:	addl	$4,%ebx
	movl	(%ebx),%eax
	testl	%eax,%eax
	jz	2f
	call	*%eax
	jmp	1b

2:	popl	%ebx
	ret




#ifdef __ELF__

.section .ctors,"aw"
__CTOR_LIST__:
	.long	0xffffffff


.section .dtors,"aw"
__DTOR_LIST__:
	.long	0xffffffff


#else // ! __ELF__
// set lists:

.globl __func_nop
__func_nop:
	ret

.stabs "___CTOR_LIST__",0,0,0,__func_nop
.stabs "___DTOR_LIST__",0x17,0,0,__func_nop

#endif

