/*  $Id: fileinfo.h,v 1.8 1999/07/16 20:18:48 shaggy Exp $
 *      File Information structure
 *      relative path: ./lib/boot/m-pc
 */ 

#include <btypes.h>

#ifndef ASM

struct FileInfo {
	_uint64	atime;		// last access time
	_uint64	ctime;		// creation time (or last change of state)
	_uint64	mtime;		// last modification time
	_uint32	size;		// size of file in bytes
	_uint16	blocks;		// size of file in blocks
	_uint16	blksize;	// size of one file block
	_uint32	rdev;		// raw device ID
	// These should probably be part of a different structure,
	// with specific calls for disk information...
	// but for now, they're here for simplicity
	// (don't expect them to stay here, though)
	_uint16	cylinders;	// total cylinders on raw device
	_uint8	heads;		// total heads on raw device
	_uint8	sectors;	// total sectors on raw device
};


#define RDEV_MAJOR(d)	((d)>>16)&0xff)
#define RDEV_MINOR(d)	((d)&0xffff)
#define RDEV_UNIT(d)	((d)&0xff)
#define RDEV_SUBINIT(d)	((d>>8)&0xff)
#define RDEV_FLAGS(d)	RDEV_SUBUNIT(d)


#else
#include "fileinfo.ofs"
#endif

