/*  $Id: libsolo.h,v 1.13 2000/01/17 23:38:50 shaggy Exp $
 *      I/O library functions for interfacing with SOLO
 *      relative path: ./lib/boot/m-pc
 */ 

#ifndef __libsolo_h__
#define __libsolo_h__

#define libsolo_VER_MAJOR	0
#define libsolo_VER_MINOR	98
#define libsolo_VER_PATCH	0
#define libsolo_VER_STR	"0.98"
#define libsolo_VER_DATE	"July 21, 1999"
#define libsolo_VER_NDATE	"07/21/99"

#include "_stdinc.h"

_extern_C_begin

typedef int solo_fd_t;

struct FileInfo;


void solo_exit(int val);
char* solo_gets(char *s, _size_t len);
int solo_puts(const char *s);
int solo_printf(const char *fmt, ...); 
int solo_vprintf(const char *fmt, _va_list args);
solo_fd_t solo_open(const char *path, int flags);
int solo_close(solo_fd_t);
int solo_read(solo_fd_t, void *buf, _size_t size);
int solo_write(solo_fd_t, const void *buf, _size_t size);
_off_t solo_lseek(solo_fd_t, _off_t ofs, int whence);
void solo_fstat(solo_fd_t, struct FileInfo *info);
void* solo_malloc(_size_t size);
void* solo_calloc(_size_t num, _size_t size);
void solo_free(void *ptr);
void* solo_realloc(void *ptr, _size_t size);
const char * solo_getenv(const char *name);

int solo_WriteMsg(const void *buf, _size_t size);
void* solo_MapBootParam(void);
void solo_UnmapBootParam(void *savemap);
void solo_set_MapBootParam(void* (*f)(void *));
void solo_set_UnmapBootParam(void* (*f)(void *));


#define SOLO_SEEK_SET	0
#define SOLO_SEEK_CUR	1
#define SOLO_SEEK_END	2

#define SOLO_O_RDONLY	0
#define SOLO_O_WRONLY	1
#define SOLO_O_RDWR	2

extern solo_fd_t solo_stdin;
extern solo_fd_t solo_stdout;
extern solo_fd_t solo_stderr;


_extern_C_end



#ifdef __cplusplus

struct BootParam;
 
class BootParamPtr {
	void *_savemap;
public:
	BootParamPtr()
		{ _savemap = solo_MapBootParam(); }
	~BootParamPtr()
		{ solo_UnmapBootParam(_savemap); }
	operator BootParam* (void)
		{ extern BootParam *bootparam; return bootparam; }
	BootParam* operator* (void)
		{ extern BootParam *bootparam; return bootparam; }
	BootParam* operator-> (void)
		{ extern BootParam *bootparam; return bootparam; }
};

#endif

#endif
