/*  $Id: mapfile.h,v 1.9 1999/07/16 20:18:48 shaggy Exp $
 *      relative path: ./lib/boot/m-pc
 */ 

#include <btypes.h>

#define DEVICE_MAPPED	0x80	// or'd with device for mapped files
				// (any that aren't raw devices)
#define DEVICE_ID_MASK	0x3f	// mask to get unique device ID

#ifdef ASM

#include "mapfile.ofs"

#else


// Note: if this structure is changed, static device descriptors
// in device.S86 need to be changed also...

struct MapFile {
	_uint32	fsize;		// file size in bytes
	_int32	mtime_hi;	// high 32 bits of time/date (in nanoseconds)
				// of last modification
				// accurate to about 4 seconds...
	_uint16	nchunks;	// number of chunks
	_uint16	reserved;	// for alignment purposes
	_uint16	unit;		// unit/flags for device
	_uint8	device;		// device type
	_uint8	namelen;	// length of name string (including null)
	char	name[0];	// variable number of chars
};


#endif

