/*  $Id: solo_io.cc,v 1.9 1999/07/16 20:18:48 shaggy Exp $
 *      I/O library functions for interfacing with SOLO
 *      relative path: ./lib/boot/m-pc
 */

#include <defines>
#include <boot/bootparam.h>
#include <boot/fileinfo.h>

#include "libsolo.h"



solo_fd_t solo_stdin;
solo_fd_t solo_stdout;
solo_fd_t solo_stderr;



extern "C" bool _bootparam_init();

extern "C" bool
_solo_io_init()
{
	static bool initialized = false;
	static bool initializing = false;
	BootParamPtr bootparam;

	if(initialized)
		return true;
	if(initializing)
		return false;
	initializing = true;
	_bootparam_init();
	solo_stdin = bootparam->console_fd;
	solo_stdout = bootparam->console_fd;
	solo_stderr = bootparam->console_fd;

	initialized = true;
	initializing = false;
	return true;
}

// Global constructor:
bool _solo_io_initialized = _solo_io_init();

