/*  $Id: video.h,v 1.2 1999/07/16 20:18:48 shaggy Exp $
 *      VESA-style video and mode info
 *      relative path: ./lib/boot/m-pc
 */

#ifndef ASM

#include <btypes.h>

/* VESA-compliant video card info */
typedef struct VidInfo VidInfo;
struct VidInfo {
	char	sig[4];
	_uint16	vers;
	_uint16	_align;		/* added to standardize alignment */
	char*	oemstring;
	_uint32	cap;
	_uint16* modelist;
	_uint16	totmem;		/* in 64K blocks */
	_uint16	oemsoftrev;
	char*	oemvendor;
	char*	oemproduct;
	char*	oemproductrev;
	_byte	_1[218];
	_byte	oemdata[256];

	enum {
		CAP_DAC8BIT=	1<<0,
		CAP_NOTVGA=	1<<1,
		CAP_NEEDBLANK=	1<<2,
		CAP_STEREO=	1<<3,
		CAP_STEREOEVC=	1<<4,
	};
};

/* mostly VESA-compliant mode structure with extensions */
struct VidMode {
	/* all VBE: */
	_uint16  attr;
	_uint8	winaattr;
	_uint8	winbattr;
	_uint16	wingran;
	_uint16	winsize;
	_uint16	winaseg;
	_uint16	winbseg;
	void*	winfunc;
	_uint16	span;

	/* VBE 1.2 */
	_uint16	xres;
	_uint16	yres;
	_uint8	xchar;
	_uint8	ychar;
	_uint8	nplanes;
	_uint8	depth;
	_uint8	nbanks;
	_uint8	memmodel;
	_uint8	banksize;
	_uint8	nimage;
	_uint8	_1;
	
	/* Direct Color */
	_uint8	redsize;
	_uint8	redpos;
	_uint8	greensize;
	_uint8	greenpos;
	_uint8	bluesize;
	_uint8	bluepos;
	_uint8	resvsize;
	_uint8	resvpos;
	_uint8	colorattr;

	/* VBE 2.0 */
	_uint32	base;
	_uint32	_2;
	_uint16	_3;

	/* VBE 3.0 */
	_uint16	linspan;
	_uint8	bnknimage;
	_uint8	linnimage;
	_uint8	linredsize;
	_uint8	linredpos;
	_uint8	lingreensize;
	_uint8	lingreenpos;
	_uint8	linbluesize;
	_uint8	linbluepos;
	_uint8	linresvsize;
	_uint8	linresvpos;
	_uint16	_align;		/* added to standardize alignment */
	_uint32	maxpixclock;

	_byte	_5[177];

	/* non-VESA extensions */
	_uint16	mode;	/* current BIOS/VESA mode */
	_uint16	crtc;	/* CRTC I/O port base address */
	VidInfo *vidinfo;

	enum {
		ATTR_SUPPORTED=		1<<0,
		ATTR_TTYOUT=		1<<2,
		ATTR_COLOR=		1<<3,
		ATTR_GRAPHICS=		1<<4,
		ATTR_NOTVGA=		1<<5,
		ATTR_NOVGAWIN=		1<<6,
		ATTR_LINEAR=		1<<7,
		ATTR_DOUBLESCAN=	1<<8,
		ATTR_INTERLACE=		1<<9,
		ATTR_TRIPLEBUF=		1<<10,
		ATTR_STEREO=		1<<11,
		ATTR_DUALDISPLAY=	1<<12
	};

	enum {
		WATTR_RELOCATABLE=	1<<0,
		WATTR_READABLE=		1<<1,
		WATTR_WRITEABLE=	1<<2,
	};

	enum {
		MMOD_TEXT=	0x00,
		MMOD_CGA=	0x01,
		MMOD_HERC=	0x02,
		MMOD_PLANAR=	0x03,
		MMOD_PACKED=	0x04,
		MMOD_NONCHAIN=	0x05,
		MMOD_DIRECT=	0x06,
		MMOD_YUV=	0x07
	};
};


#else
#include "video.ofs"
#endif

