/*  $Id: bits.hh,v 1.4 1999/07/16 20:18:48 shaggy Exp $
 *      relative path: ./lib/c++
 */

#ifndef __bits_hh__
#define __bits_hh__

// code for bit-level manipulations


inline void set_bits(uint8 &b, int first, int nbits, uint n)
{ uint bmask=(1<<nbits)-1; b = (b&(0xff^(bmask<<first)))|((n&bmask)<<first); }

inline void set_bits(uint16 &b, int first, int nbits, uint n)
{ uint bmask=(1<<nbits)-1; b = (b&(0xff^(bmask<<first)))|((n&bmask)<<first); }

inline void set_bits(uint32 &b, int first, int nbits, uint n)
{ uint bmask=(1<<nbits)-1; b = (b&(0xff^(bmask<<first)))|((n&bmask)<<first); }

inline void set_bits(uint64 &b, int first, int nbits, uint n)
{ uint bmask=(1<<nbits)-1; b = (b&(0xff^(bmask<<first)))|((n&bmask)<<first); }

inline uint get_bits(uint8 &b, int first, int nbits)
{ return (b>>first)&((1<<nbits)-1); }

inline uint get_bits(uint16 &b, int first, int nbits)
{ return (b>>first)&((1<<nbits)-1); }

inline uint get_bits(uint32 &b, int first, int nbits)
{ return (b>>first)&((1<<nbits)-1); }

inline uint get_bits(uint64 &b, int first, int nbits)
{ return (b>>first)&((1<<nbits)-1); }

#endif
