/*  $Id: vstream.cc,v 1.7 2000/01/12 03:44:44 shaggy Exp $
 *      relative path: lib/c++
 *  
 *  Copyright (c) 1996 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is part of the ShagOS distribution, and may be freely used and
 *  distributed by the terms of the ShagWare General Public License (SGPL),
 *  version 2, or, at your option, any newer official version of that License.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND,
 *  INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 *  FITNESS FOR A PARTICULAR PURPOSE, AND WILL NOT BE LIABLE FOR ANY DAMAGES.
 *  For more warranty details, see the ShagWare General Public License, which
 *  should have been received with this program, in a file called 'lic_spl2.txt'
 *  If this license is missing, please contact the author and describe how
 *  this software was obtained.  Email: shaggy@csh.rit.edu
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/members/shaggy
 */

#include "vstream.hh"

ssize_t
vstream::read(VecAny)
{ return -1; }

ssize_t
vstream::write(CVecAny)
{ return -1; }

off_t
vstream::seek(off_t, int) 
{ return -1; }

off_t
vstream::tell() const
{ return -1; }

vstream*
vstream::dup() const
{ return 0; }


ssize_t
vstream::read_at(off_t p, VecAny buf)
{
	off_t cur = tell();
	seek(p);
	ssize_t n = read(buf);
	seek(cur);
	return n;
}

ssize_t
vstream::write_at(off_t p, CVecAny buf)
{
	off_t cur = tell();
	seek(p);
	ssize_t n = write(buf);
	seek(cur);
	return n;
}

ssize_t
vstream::read_through(Str buf, char ch)
{
	for(size_t n = 0; n < buf.count(); n++) {
		if(!(read(Str(buf[n])))) return n;
		if(buf[n] == ch) return n+1;
	}
	return buf.count();
}

ssize_t
vstream::read_through(WStr buf, wchar_t ch)
{
	for(size_t n = 0; n < buf.count(); n++) {
		if(!(read(WStr(buf[n])))) return n;
		if(buf[n] == ch) return n+1;
	}
	return buf.count();
}


// returns number of bytes flushed/purged
ssize_t
vstream::flush(int)
{
	return 0;
}

