/*  $Id: vstream.hh,v 1.6 2000/01/11 07:32:38 shaggy Exp $
 *      relative path: ./lib/c++
 */

#ifndef __vstream_h__
#define __vstream_h__

#ifndef _POSIX_SOURCE
# define _POSIX_SOURCE
#endif

#include <sys/types.h>
#include <stdx1.h>

#ifdef __notemplates
	typedef void* VecAny;
	typedef const void* CVecAny;
	struct Vec_void { Vec_void(void*, int); };
	typedef Vec_void CVec_void;
	typedef Vec_void Str;
	typedef Vec_void WStr;
#else
#	include <Vec>
#endif


#ifndef SEEK_SET
#define SEEK_SET	0
#define SEEK_CUR	1
#define SEEK_END	2
#endif


class vstream {
public:
	enum io_mode {
		READ = 0x0001,
		WRITE = 0x0002,
		APPEND = 0x0004,
		CREATE = 0x0008,
		TRUNC = 0x0010,
		NOBLOCK = 0x0020,
		SYNC = 0x0040
	};	
	virtual ~vstream() {}
	virtual ssize_t read(VecAny buf);
	virtual ssize_t read_through(Str buf, char ch);
	virtual ssize_t read_through(WStr buf, wchar_t ch);
	virtual ssize_t write(CVecAny buf);
	virtual off_t seek(off_t p, int whence = SEEK_SET);
	virtual off_t tell() const;
	virtual ssize_t read_at(off_t p, VecAny buf);
	virtual ssize_t write_at(off_t p, CVecAny buf);
	virtual ssize_t flush(int flags = WRITE);
	virtual vstream* dup() const;
	ssize_t purge() { return flush(READ|WRITE|TRUNC|NOBLOCK); }
	ssize_t purge_input() { return flush(READ|TRUNC|NOBLOCK); }
	ssize_t purge_output() { return flush(WRITE|TRUNC|NOBLOCK); }
	ssize_t read(void *adr, size_t size) 
		{ return read(Vec_void(adr, size)); }
	ssize_t write(const void *adr, size_t size) 
		{ return write(CVec_void(adr, size)); }
	ssize_t read_at(off_t p, void *adr, size_t size) 
		{ return read_at(p, Vec_void(adr, size)); }
	ssize_t write_at(off_t p, const void *adr, size_t size) 
		{ return write_at(p, CVec_void(adr, size)); }
	void rewind() { seek(0, SEEK_SET); }
};

#endif
