/*  $Id: ParsePath.hh,v 1.4 1999/07/16 20:18:50 shaggy Exp $
 *      relative path: ./lib/parse
 */

#ifndef __ParsePath_hh__
#define __ParsePath_hh__

#ifndef NAME_MAX
#define NAME_MAX	255	// max chars in a filename
#endif
#ifndef PATH_MAX
#define PATH_MAX	1024	// max chars in a pathname
#endif



// OPT: could compute each part when it is first accessed only
//	or could just make into separate classes, and inherit only
//	the parts needed


class ParsePath {
	bool absolute;
	char *end;
	char *next_dir;
	char base[NAME_MAX];
	char dir[PATH_MAX];
public:
	void parse(const char *path);
	ParsePath();
	ParsePath(const char *path)	{ parse(path); }
	const bool is_absolute() const	{ return absolute; }
	const bool has_dir() const	{ return dir[0] != 0; }
	const bool has_base() const	{ return base[0] != 0; }
	const bool is_root() const	{ return absolute && !has_dir() && !has_base(); }
	const char* get_dir() const	{ return dir; }
	const char* get_base() const	{ return base; }
	const char* get_ext(const char *div) const;
	const char* get_suffix(const char *div) const;
	bool has_suffix(const char *suffix) const;
	bool change_suffix(char *nb, const char *olds, const char *news) const;
	bool get_next_dir(char *nd = 0);
	void first_dir()
		{ next_dir = dir; }
	bool first_dir(char *nd)
		{ first_dir(); return get_next_dir(nd); }
	void get_dir_path(char *np) const;
};

#endif
