/*  $Id: signal.h,v 1.4 1999/07/16 20:18:50 shaggy Exp $
 *      relative path: ./lib/posix
 */

#ifndef __signal_h__
#define __signal_h__

#include "_stdinc.h"

_extern_C_begin

typedef int	sig_atomic_t;
typedef void (*__sigfunc_t)(int);

#define SIG_DFL	((__sigfunc_t)0)
#define SIG_IGN	((__sigfunc_t)1)
#define SIG_ERR	((__sigfunc_t)-1)

#define SA_NOCLDSTOP	1

#define SIG_BLOCK          0
#define SIG_UNBLOCK        1
#define SIG_SETMASK        2

#define SIGINT		 2
#define SIGILL		 4
#define SIGABRT		 6
#define SIGFPE		 8
#define SIGSEGV		11
#define SIGTERM		15

__sigfunc_t signal(int sig, __sigfunc_t func);
int raise(int sig);


#ifdef _POSIX_SOURCE

#define SIGHUP		 1
#define SIGQUIT		 3
#define SIGKILL		 9
#define SIGUSR1		10
#define SIGUSR2		12
#define SIGPIPE		13
#define SIGALRM		14
#define SIGCHLD		17
#define SIGCONT		18
#define SIGSTOP		19
#define SIGTSTP		20
#define SIGTTIN		21
#define SIGTTOU		22

typedef unsigned int sigset_t;

struct sigaction {
	__sigfunc_t sa_handler;
	sigset_t sa_mask;
	int sa_flags;
};

int kill(_pid_t pid, int sig);
int sigaction(int sig, const struct sigaction *act,
			struct sigaction *oact);
static __inline__ int sigaddset(sigset_t *set, int signo) {
	*set |= (1<<signo); return 0; }
static __inline__ int sigdelset(sigset_t *set, int signo) {
	*set &= ~(1<<signo); return 0; }
static __inline__ int sigemptyset(sigset_t *set) {
	*set = 0; return 0; }
static __inline__ int sigfillset(sigset_t *set) {
	*set = 0xffffffff; return 0; }
static __inline__ int sigismember(const sigset_t *set, int signo) {
	return((*set & (1<<signo)) > 0); }
int sigpending(sigset_t *set);
int sigprocmask(int how, const sigset_t *set, sigset_t *oset);
int sigsuspend(const sigset_t *sigmask);

#endif

_extern_C_end

#endif
