/*  $Id: time.h,v 1.5 1999/07/16 20:18:50 shaggy Exp $
 *      relative path: ./lib/posix
 */

#ifndef __time_h__
#define __time_h__

#include "_stdinc.h"
#include "_nullst.h"

_extern_C_begin

#define CLOCKS_PER_SEC	_HZ

typedef _clock_t clock_t;
typedef _time_t time_t;

struct tm {
	_uint8	tm_sec;
	_uint8	tm_min;
	_uint8	tm_hour;
	_uint8	tm_mday;
	_uint16	yday;	/* since Jan 1 */
	_uint8	tm_wday;	/* week day 0=sunday */
	_uint8	tm_mon;		
	_uint16	tm_year;	/* since 1900 */
	_int8	tm_isdst;	/* >0 = DST 0= standard <0=unknown */
}; 

clock_t clock(void);
double difftime(time_t time1, time_t time0);
time_t mktime(struct tm *tp);
time_t time(time_t *timer);
_sz *asctime(const struct tm *tp);
_sz *ctime(const time_t *timer);
struct tm *gmtime(const time_t *timer);
struct tm *localtime(const time_t *timer);
size_t *strftime(_sz *s, size_t maxsize, _csz *fmt, const struct tm *tp);

#ifdef _POSIX_SOURCE

#define CLK_TCK _HZ

void tzset(void);

#endif

_extern_C_end

#endif
