/*  $Id: devio.h,v 1.6 1999/06/01 05:42:45 shaggy Exp $
 *      Device I/O interface:
 */

#define DEVIO_ID	0x00		// device ID
#define DEVIO_RESV	0x01		// reserved
#define DEVIO_FLAGS	0x02		// default flags
#define DEVIO_BLK2SIZE	0x03		// default log2(blocksize)
#define DEVIO_OPEN	0x04		// open device
#define DEVIO_CLOSE	0x06		// close device
#define DEVIO_READ	0x08		// read function
#define DEVIO_WRITE	0x0a		// write function
#define DEVIO_SIZEOF	0x0c


// Open file descriptor:

#define FD_DEVPTR	0x00	// pointer to device structure
#define FD_MAPPTR	0x02	// pointer to mapfile entry (null if unused)
#define FD_POS		0x04	// current position in file
#define FD_UNIT		0x08	// device unit number
#define FD_BLK2SIZE	0x0a	// log2(block size)
#define FD_FLAGS	0x0b	// device flags
#define FD_FSIZE	0x0c	// total file size
#define FD_DATA		0x10	// 16 bytes of device-dependent data
#define FD_SIZEOF	0x20

#define FD_FLAG_READ	0x01	// device can be read from
#define FD_FLAG_WRITE	0x02	// device can be written to
#define FD_FLAG_FILE	0x08	// fd represents a mapped file
#define FD_FLAG_4K	0x10	// buffer cannot cross 4K boundary
#define FD_FLAG_64K	0x20	// buffer cannot cross 64K boundary
#define FD_FLAG_BLOCK	0x40	// device is a block device
#define FD_FLAG_CHAR	0x80	// device is a character device

